// CLSDMXCPLUGINIMPL.H : Deklaration von TclsDMXCPluginImpl

#ifndef clsDMXCPluginImplH
#define clsDMXCPluginImplH

#define ATL_APARTMENT_THREADED

#include "uDMX_TLB.H"

/* this is libusb, see http://libusb.sourceforge.net/ */
#include "usb_DMX.h"

#define USBDEV_SHARED_VENDOR    0x16C0  /* VOTI */
#define USBDEV_SHARED_PRODUCT   0x05DC  /* Obdev's free shared PID */
/* Use obdev's generic shared VID/PID pair and follow the rules outlined
 * in firmware/usbdrv/USBID-License.txt.
 */
#define cmd_SetChannelRange 2


/////////////////////////////////////////////////////////////////////////////
// TclsDMXCPluginImpl     Implementiert IclsDMXCPlugin, die Standard-Schnittstelle von clsDMXCPlugin
// Threading-Modell : Apartment
// Duale Schnittstelle: TRUE
// Ereignisuntersttzung  : FALSE
// Standard-Programm-ID : uDMX.clsDMXCPlugin
// Beschreibung    :
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TclsDMXCPluginImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TclsDMXCPluginImpl, &CLSID_clsDMXCPlugin>,
  public IDispatchImpl<IclsDMXCPlugin, &IID_IclsDMXCPlugin, &LIBID_uDMX>,
  DUALINTERFACE_IMPL(clsDMXCPlugin, _IDMXCModule),
  DUALINTERFACE_IMPL(clsDMXCPlugin, _IDMXCPlugin),
  DUALINTERFACE_IMPL(clsDMXCPlugin, _IPluginHelper)
{
public:
  TclsDMXCPluginImpl()
  {
    m_hUSB          = 0 ;
    m_numOfDevices  = 0 ;
    wsName          = "uDMX Plugin" ;
  }
  IPluginHelper* m_Helper ;

  struct usb_bus      *bus;
  struct usb_device   *dev;
  usb_dev_handle      *m_hUSB;

  WideString  wsApp ;
  WideString  wsFile ;
  WideString  wsName ;

  int m_numOfDevices ;

  int usbStringGet(usb_dev_handle *dev, int index, 
                   int langid, char *buf, int buflen) ;  

  // Bei der Registrierung des Objekts verwendete Daten
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("uDMX.clsDMXCPlugin");
  DECLARE_DESCRIPTION("");

  // Funktion wurde zum Aus- und Eintragen des Objekts aufgerufen
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TclsDMXCPluginImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TclsDMXCPluginImpl)
  COM_INTERFACE_ENTRY(IclsDMXCPlugin)
  COM_INTERFACE_ENTRY2(IDispatch, IclsDMXCPlugin)
  DUALINTERFACE_ENTRY(_IDMXCModule)
  DUALINTERFACE_ENTRY(_IDMXCPlugin)
  DUALINTERFACE_ENTRY(_IPluginHelper)
END_COM_MAP()

// IclsDMXCPlugin
public:
 
  STDMETHOD(get_PluginName(BSTR* Value));
  STDMETHOD(get_ModuleInfo(_Type_Module_Info** Param1));
  STDMETHOD(Configure(VARIANT_BOOL* Param1));
  STDMETHOD(Disable(VARIANT_BOOL* Param1));
  STDMETHOD(Enable(VARIANT_BOOL* Param1));
  STDMETHOD(Init(BSTR* CallingAppTitle, BSTR* MyFileName,
      _IPluginHelper** DMXCPluginHelper, VARIANT_BOOL* Param4));
  STDMETHOD(MessageHandle(MSGs* Msg, long* Arg1, long* Arg2, long* Param4));
  STDMETHOD(Term(VARIANT_BOOL* Param1));
  STDMETHOD(AuthenticationStage1(BSTR* Param1));
  STDMETHOD(AuthenticationStage2(BSTR* Response, VARIANT_BOOL* Param2));
  STDMETHOD(AuthenticationStage3(BSTR* Challenge, BSTR* Param2));
  STDMETHOD(AuthenticationStage4(VARIANT_BOOL* Success,
      VARIANT_BOOL* Param2));
  STDMETHOD(ChannelGetValue(long* Channel, long* Param2));
  STDMETHOD(ChannelIsDimmer(long* Channel, VARIANT_BOOL* Param2));
  STDMETHOD(DMXInSetChannel(long* Channel, long* Value,
      VARIANT_BOOL* Param3));
  STDMETHOD(get_ChannelMAXCHANNELS(long* Param1));
  STDMETHOD(get_Devices(_IDevices** Param1));
  STDMETHOD(get_DEVisKey(BSTR* Param1));
  STDMETHOD(get_HighResTimer(_ITimerEx** Param1));
  STDMETHOD(get_Messages(_IMessages** Param1));
  STDMETHOD(get_MEVPKey(BSTR* Param1));
  STDMETHOD(get_MyStream(_IDMXMixerChannel** Param1));
  STDMETHOD(get_Project(_IProject** Param1));
  STDMETHOD(get_Settings(_ISettings** Param1));
  STDMETHOD(get_Storage(_IDataStorage** Param1));
  STDMETHOD(get_Translator(_ITranslator** Param1));
  STDMETHOD(GetLocalSetting(BSTR* Key, VARIANT* Default, BSTR* Param3));
  STDMETHOD(SaveLocalSetting(BSTR* Key, BSTR* Setting));
  STDMETHOD(SetChannel(long* Channel, long* Value, VARIANT_BOOL* Param3));
};

#endif //clsDMXCPluginImplH
